﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using Database;

namespace ADPolices
{
  public class Controller
    {
      private static readonly Context Db = new Context();
      public static string Message { get; set; }

      public static List<Group> SelectGroups()
      {
          return Db.Groups.Any() ? Db.Groups.ToList() : null;
      }

      public List<GroupPolice> SelectGroupPolices()
      {
          return Db.GroupPolices.Any() ? Db.GroupPolices.ToList() : null;
      }

      public List<Group> SelectFilteredGroups(int politicId, string ownGName)
      {
          try
          {
              if (politicId == 0) politicId++;
              var allgroup = Controller.SelectGroups();
              return allgroup.Where(group => group.GroupPoliceId == politicId && group.Name != ownGName).ToList();
          }
         catch (Exception error) { Message = error.Message; return null; }
      }

      public void InsertGroup(Group argGroup)
      {
          using (var dbContext = new Context())
          {
              try
              {
                  if (dbContext.Groups.Any(p => p.Name == argGroup.Name)) return;
                  dbContext.Groups.Add(argGroup);
                  dbContext.SaveChanges();
              }
              catch (Exception error)
              {
                  throw new FaultException(error.Message);
              }
          }
      }
      
      public void DeleteGroup(Group argGroup)
      {
          using (var dbContext = new Context())
          {
              try
              {
                  dbContext.Groups.Remove(dbContext.Groups.First(p => p.Id == argGroup.Id));
                  dbContext.SaveChanges();
              }
              catch (Exception error)
              {
                  throw new FaultException(error.Message);
              }
          }
      }


    }
}